Index: pjproject/trunk/aconfigure
===================================================================
--- pjproject/trunk/aconfigure	(revision 4700)
+++ pjproject/trunk/aconfigure	(revision 4701)
@@ -651,4 +651,6 @@
 ac_external_pa
 ac_pjmedia_snd
+ac_pjmedia_resample
+ac_external_srtp
 ac_external_gsm
 ac_external_speex
@@ -743,4 +745,6 @@
 with_external_speex
 with_external_gsm
+with_external_srtp
+enable_resample
 enable_sound
 with_external_pa
@@ -1410,4 +1414,5 @@
   --enable-epoll          Use /dev/epoll ioqueue on Linux (experimental)
   --enable-shared         Build shared libraries
+  --disable-resample      Disable resampling implementations
   --disable-sound         Exclude sound (i.e. use null sound)
   --disable-oss           Disable OSS audio (default: not disabled)
@@ -1424,6 +1429,5 @@
   --disable-speex-codec   Exclude Speex codecs in the build
   --disable-ilbc-codec    Exclude iLBC codec in the build
-  --enable-libsamplerate  Link with libsamplerate when available. Note that
-                          PJMEDIA_RESAMPLE_IMP must also be configured
+  --enable-libsamplerate  Link with libsamplerate when available.
   --enable-resample-dll   Build libresample as shared library
   --disable-sdl           Disable SDL (default: not disabled)
@@ -1456,4 +1460,9 @@
                           accessible to use (hint: use CFLAGS and LDFLAGS env
                           var to set the include/lib paths)
+  --with-external-srtp    Use external SRTP development files, not the one in
+                          "third_party" directory. When this option is set,
+                          make sure that SRTP is accessible to use (hint: use
+                          CFLAGS and LDFLAGS env var to set the include/lib
+                          paths)
   --with-external-pa      Use external PortAudio development files, not the
                           one in "third_party" directory. When this option is
@@ -5789,4 +5798,54 @@
 
 
+ac_external_srtp=0
+
+
+# Check whether --with-external-srtp was given.
+if test "${with_external_srtp+set}" = set; then :
+  withval=$with_external_srtp;
+	if test "x$with_external_srtp" != "xno"; then
+		# Test SRTP installation
+		{ $as_echo "$as_me:${as_lineno-$LINENO}: checking if external SRTP devkit is installed" >&5
+$as_echo_n "checking if external SRTP devkit is installed... " >&6; }
+		cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+#include <srtp/srtp.h>
+
+int
+main ()
+{
+srtp_init();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_compile "$LINENO"; then :
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes!!" >&5
+$as_echo "yes!!" >&6; }
+				   ac_external_srtp="1"
+
+else
+  as_fn_error $? "Unable to use SRTP. If SRTP development files are not available in the default locations, use CFLAGS and LDFLAGS env var to set the include/lib paths" "$LINENO" 5
+fi
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+	fi
+
+
+fi
+
+
+
+ac_pjmedia_resample=libresample
+
+# Check whether --enable-resample was given.
+if test "${enable_resample+set}" = set; then :
+  enableval=$enable_resample; if test "$enable_resample" = "no"; then
+		ac_pjmedia_resample=none
+		{ $as_echo "$as_me:${as_lineno-$LINENO}: result: Checking if resampling is disabled...yes" >&5
+$as_echo "Checking if resampling is disabled...yes" >&6; }
+	       fi
+
+fi
+
 
 
@@ -6258,4 +6317,5 @@
 fi
 
+	      ac_pjmedia_resample=libsamplerate
 else
   { $as_echo "$as_me:${as_lineno-$LINENO}: result: Skipping libsamplerate detection" >&5
@@ -7455,5 +7515,5 @@
 
 		ac_fn_c_check_header_mongrel "$LINENO" "vo-amrwbenc/enc_if.h" "ac_cv_header_vo_amrwbenc_enc_if_h" "$ac_includes_default"
-if test "x$ac_cv_header_vo_amrwbenc_enc_if_h" = xyes; then :
+if test "x$ac_cv_header_vo_amrwbenc_enc_if_h" = x""yes; then :
   opencore_amrwb_enc_h_present=1
 fi
@@ -7461,5 +7521,5 @@
 
 		ac_fn_c_check_header_mongrel "$LINENO" "opencore-amrwb/dec_if.h" "ac_cv_header_opencore_amrwb_dec_if_h" "$ac_includes_default"
-if test "x$ac_cv_header_opencore_amrwb_dec_if_h" = xyes; then :
+if test "x$ac_cv_header_opencore_amrwb_dec_if_h" = x""yes; then :
   opencore_amrwb_dec_h_present=1
 fi
@@ -7468,5 +7528,5 @@
 		{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for D_IF_init in -lopencore-amrwb" >&5
 $as_echo_n "checking for D_IF_init in -lopencore-amrwb... " >&6; }
-if ${ac_cv_lib_opencore_amrwb_D_IF_init+:} false; then :
+if test "${ac_cv_lib_opencore_amrwb_D_IF_init+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
@@ -7502,5 +7562,5 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_opencore_amrwb_D_IF_init" >&5
 $as_echo "$ac_cv_lib_opencore_amrwb_D_IF_init" >&6; }
-if test "x$ac_cv_lib_opencore_amrwb_D_IF_init" = xyes; then :
+if test "x$ac_cv_lib_opencore_amrwb_D_IF_init" = x""yes; then :
   opencore_amrwb_dec_present=1 && LIBS="$LIBS -lopencore-amrwb"
 fi
@@ -7508,5 +7568,5 @@
 		{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for E_IF_init in -lvo-amrwbenc" >&5
 $as_echo_n "checking for E_IF_init in -lvo-amrwbenc... " >&6; }
-if ${ac_cv_lib_vo_amrwbenc_E_IF_init+:} false; then :
+if test "${ac_cv_lib_vo_amrwbenc_E_IF_init+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
@@ -7542,5 +7602,5 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_vo_amrwbenc_E_IF_init" >&5
 $as_echo "$ac_cv_lib_vo_amrwbenc_E_IF_init" >&6; }
-if test "x$ac_cv_lib_vo_amrwbenc_E_IF_init" = xyes; then :
+if test "x$ac_cv_lib_vo_amrwbenc_E_IF_init" = x""yes; then :
   opencore_amrwb_enc_present=1 && LIBS="$LIBS -lvo-amrwbenc"
 fi
@@ -7601,5 +7661,5 @@
 
 		ac_fn_c_check_header_mongrel "$LINENO" "SKP_Silk_SDK_API.h" "ac_cv_header_SKP_Silk_SDK_API_h" "$ac_includes_default"
-if test "x$ac_cv_header_SKP_Silk_SDK_API_h" = xyes; then :
+if test "x$ac_cv_header_SKP_Silk_SDK_API_h" = x""yes; then :
   silk_h_present=1
 fi
@@ -7608,5 +7668,5 @@
 		{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for SKP_Silk_SDK_get_version in -lSKP_SILK_SDK" >&5
 $as_echo_n "checking for SKP_Silk_SDK_get_version in -lSKP_SILK_SDK... " >&6; }
-if ${ac_cv_lib_SKP_SILK_SDK_SKP_Silk_SDK_get_version+:} false; then :
+if test "${ac_cv_lib_SKP_SILK_SDK_SKP_Silk_SDK_get_version+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
@@ -7642,5 +7702,5 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_SKP_SILK_SDK_SKP_Silk_SDK_get_version" >&5
 $as_echo "$ac_cv_lib_SKP_SILK_SDK_SKP_Silk_SDK_get_version" >&6; }
-if test "x$ac_cv_lib_SKP_SILK_SDK_SKP_Silk_SDK_get_version" = xyes; then :
+if test "x$ac_cv_lib_SKP_SILK_SDK_SKP_Silk_SDK_get_version" = x""yes; then :
   silk_present=1 && LIBS="$LIBS -lSKP_SILK_SDK"
 fi
Index: pjproject/trunk/aconfigure.ac
===================================================================
--- pjproject/trunk/aconfigure.ac	(revision 4700)
+++ pjproject/trunk/aconfigure.ac	(revision 4701)
@@ -529,4 +529,35 @@
 
 
+dnl # Use external SRTP installation
+AC_SUBST(ac_external_srtp,0)
+AC_ARG_WITH(external-srtp,
+    AC_HELP_STRING([--with-external-srtp],
+		   [Use external SRTP development files, not the one in "third_party" directory. When this option is set, make sure that SRTP is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
+    [
+	if test "x$with_external_srtp" != "xno"; then
+		# Test SRTP installation
+		AC_MSG_CHECKING([if external SRTP devkit is installed])
+		AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <srtp/srtp.h>
+						     ]],
+						  [srtp_init();])],
+				  [AC_MSG_RESULT(yes!!)
+				   ac_external_srtp="1"
+				   ],
+				  [AC_MSG_ERROR([Unable to use SRTP. If SRTP development files are not available in the default locations, use CFLAGS and LDFLAGS env var to set the include/lib paths])])
+	fi
+    ]
+    )
+
+
+dnl # Resample implementation
+AC_SUBST(ac_pjmedia_resample,libresample)
+AC_ARG_ENABLE(resample,
+	      AC_HELP_STRING([--disable-resample],
+			     [Disable resampling implementations]),
+	      [if test "$enable_resample" = "no"; then
+		[ac_pjmedia_resample=none]
+		AC_MSG_RESULT([Checking if resampling is disabled...yes])
+	       fi]
+	      )
 
 dnl # Sound device backend selection
@@ -832,6 +863,7 @@
 AC_ARG_ENABLE(libsamplerate,
 	      AC_HELP_STRING([--enable-libsamplerate],
-			     [Link with libsamplerate when available. Note that PJMEDIA_RESAMPLE_IMP must also be configured]),
-	      [ AC_CHECK_LIB(samplerate,src_new) ],
+			     [Link with libsamplerate when available.]),
+	      [ AC_CHECK_LIB(samplerate,src_new) ]
+	      [ac_pjmedia_resample=libsamplerate],
 	      AC_MSG_RESULT([Skipping libsamplerate detection])
 	     )
Index: pjproject/trunk/build.mak.in
===================================================================
--- pjproject/trunk/build.mak.in	(revision 4700)
+++ pjproject/trunk/build.mak.in	(revision 4701)
@@ -27,13 +27,26 @@
 export APP_THIRD_PARTY_EXT :=
 export APP_THIRD_PARTY_LIBS :=
-export APP_THIRD_PARTY_LIB_FILES := $(PJ_DIR)/third_party/lib/libmilenage-$(LIB_SUFFIX) $(PJ_DIR)/third_party/lib/libsrtp-$(LIB_SUFFIX)
-ifeq ($(PJ_SHARED_LIBRARIES),)
-APP_THIRD_PARTY_LIBS += -lmilenage-$(TARGET_NAME) -lsrtp-$(TARGET_NAME)
-else
-APP_THIRD_PARTY_LIBS += -lmilenage -lsrtp
-APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libmilenage.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libmilenage.$(SHLIB_SUFFIX) \
-			     $(PJ_DIR)/third_party/lib/libsrtp.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libsrtp.$(SHLIB_SUFFIX)
-endif
-
+export APP_THIRD_PARTY_LIB_FILES := $(PJ_DIR)/third_party/lib/libmilenage-$(LIB_SUFFIX)
+ifeq ($(PJ_SHARED_LIBRARIES),)
+APP_THIRD_PARTY_LIBS += -lmilenage-$(TARGET_NAME)
+else
+APP_THIRD_PARTY_LIBS += -lmilenage
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libmilenage.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libmilenage.$(SHLIB_SUFFIX)
+endif
+
+ifeq (@ac_external_srtp@,1)
+# External SRTP library
+APP_THIRD_PARTY_EXT += -lsrtp
+else
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libsrtp-$(LIB_SUFFIX)
+ifeq ($(PJ_SHARED_LIBRARIES),)
+APP_THIRD_PARTY_LIBS += -lsrtp-$(TARGET_NAME)
+else
+APP_THIRD_PARTY_LIBS += -lsrtp
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libsrtp.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libsrtp.$(SHLIB_SUFFIX)
+endif
+endif
+
+ifeq (@ac_pjmedia_resample@,libresample)
 APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libresample-$(LIB_SUFFIX)
 ifeq ($(PJ_SHARED_LIBRARIES),)
@@ -48,4 +61,5 @@
 APP_THIRD_PARTY_LIBS += -lresample
 APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libresample.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libresample.$(SHLIB_SUFFIX)
+endif
 endif
 
Index: pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- pjproject/trunk/pjmedia/build/Makefile	(revision 4700)
+++ pjproject/trunk/pjmedia/build/Makefile	(revision 4701)
@@ -3,8 +3,4 @@
 
 THIRD_PARTY:=$(PJDIR)/third_party
-
-SRTP_INC=$(CC_INC)$(THIRD_PARTY)/build/srtp \
-	 $(CC_INC)$(THIRD_PARTY)/srtp/crypto/include \
-	 $(CC_INC)$(THIRD_PARTY)/srtp/include
 
 include $(PJDIR)/build/common.mak
@@ -49,6 +45,5 @@
 		   $(CC_INC)../../pjmedia/include \
 		   $(CC_INC)../../pjnath/include \
-		   $(CC_INC)../.. \
-		   $(SRTP_INC) 
+		   $(CC_INC)../..
 export _CXXFLAGS:= $(_CFLAGS) $(CC_CXXFLAGS) $(OS_CXXFLAGS) $(M_CXXFLAGS) \
 		   $(HOST_CXXFLAGS) $(CXXFLAGS)
@@ -72,5 +67,5 @@
 			g711.o jbuf.o master_port.o mem_capture.o mem_player.o \
 			null_port.o plc_common.o port.o splitcomb.o \
-			resample_resample.o resample_libsamplerate.o \
+			resample_resample.o resample_libsamplerate.o resample_speex.o \
 			resample_port.o rtcp.o rtcp_xr.o rtp.o \
 			sdp.o sdp_cmp.o sdp_neg.o session.o silencedet.o \
Index: pjproject/trunk/pjmedia/build/os-auto.mak.in
===================================================================
--- pjproject/trunk/pjmedia/build/os-auto.mak.in	(revision 4700)
+++ pjproject/trunk/pjmedia/build/os-auto.mak.in	(revision 4701)
@@ -130,4 +130,40 @@
 
 #
+# SRTP
+#
+ifeq (@ac_external_srtp@,1)
+# External SRTP
+export CFLAGS += -DPJMEDIA_EXTERNAL_SRTP=1
+else
+# Our SRTP in third_party
+export CFLAGS += -I$(THIRD_PARTY)/build/srtp \
+	 -I$(THIRD_PARTY)/srtp/crypto/include \
+	 -I$(THIRD_PARTY)/srtp/include
+
+endif
+
+#
+# Resample
+#
+AC_PJMEDIA_RESAMPLE=@ac_pjmedia_resample@
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),none)
+# No resample support
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_NONE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libresample)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBRESAMPLE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libsamplerate)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBSAMPLERATE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),speex)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_SPEEX
+endif
+
+#
 # PortAudio
 #
Index: pjproject/trunk/pjmedia/build/os-darwinos.mak
===================================================================
--- pjproject/trunk/pjmedia/build/os-darwinos.mak	(revision 4700)
+++ pjproject/trunk/pjmedia/build/os-darwinos.mak	(revision 4701)
@@ -79,4 +79,40 @@
 endif
 
+#
+# Resample
+#
+AC_PJMEDIA_RESAMPLE=libresample
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),none)
+# No resample support
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_NONE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libresample)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBRESAMPLE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libsamplerate)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBSAMPLERATE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),speex)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_SPEEX
+endif
+
+#
+# SRTP
+#
+#ifeq (@ac_external_srtp@,1)
+ifeq (0,1)
+# External SRTP
+export CFLAGS += -DPJMEDIA_EXTERNAL_SRTP=1
+else
+# Our SRTP in third_party
+export CFLAGS += -I$(THIRD_PARTY)/build/srtp \
+	 -I$(THIRD_PARTY)/srtp/crypto/include \
+	 -I$(THIRD_PARTY)/srtp/include
+
+endif
 
 #
Index: pjproject/trunk/pjmedia/build/os-linux.mak
===================================================================
--- pjproject/trunk/pjmedia/build/os-linux.mak	(revision 4700)
+++ pjproject/trunk/pjmedia/build/os-linux.mak	(revision 4701)
@@ -73,4 +73,40 @@
 endif
 
+#
+# Resample
+#
+AC_PJMEDIA_RESAMPLE=libresample
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),none)
+# No resample support
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_NONE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libresample)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBRESAMPLE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libsamplerate)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBSAMPLERATE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),speex)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_SPEEX
+endif
+
+#
+# SRTP
+#
+#ifeq (@ac_external_srtp@,1)
+ifeq (0,1)
+# External SRTP
+export CFLAGS += -DPJMEDIA_EXTERNAL_SRTP=1
+else
+# Our SRTP in third_party
+export CFLAGS += -I$(THIRD_PARTY)/build/srtp \
+	 -I$(THIRD_PARTY)/srtp/crypto/include \
+	 -I$(THIRD_PARTY)/srtp/include
+
+endif
 
 #
Index: pjproject/trunk/pjmedia/build/os-rtems.mak
===================================================================
--- pjproject/trunk/pjmedia/build/os-rtems.mak	(revision 4700)
+++ pjproject/trunk/pjmedia/build/os-rtems.mak	(revision 4701)
@@ -7,2 +7,3 @@
 export SOUND_OBJS = $(NULLSOUND_OBJS)
 
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBRESAMPLE
Index: pjproject/trunk/pjmedia/build/os-win32.mak
===================================================================
--- pjproject/trunk/pjmedia/build/os-win32.mak	(revision 4700)
+++ pjproject/trunk/pjmedia/build/os-win32.mak	(revision 4701)
@@ -75,4 +75,40 @@
 endif
 
+#
+# Resample
+#
+AC_PJMEDIA_RESAMPLE=libresample
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),none)
+# No resample support
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_NONE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libresample)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBRESAMPLE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),libsamplerate)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_LIBSAMPLERATE
+endif
+
+ifeq ($(AC_PJMEDIA_RESAMPLE),speex)
+export CFLAGS += -DPJMEDIA_RESAMPLE_IMP=PJMEDIA_RESAMPLE_SPEEX
+endif
+
+#
+# SRTP
+#
+#ifeq (@ac_external_srtp@,1)
+ifeq (0,1)
+# External SRTP
+export CFLAGS += -DPJMEDIA_EXTERNAL_SRTP=1
+else
+# Our SRTP in third_party
+export CFLAGS += -I$(THIRD_PARTY)/build/srtp \
+	 -I$(THIRD_PARTY)/srtp/crypto/include \
+	 -I$(THIRD_PARTY)/srtp/include
+
+endif
 
 #
Index: pjproject/trunk/pjmedia/include/pjmedia/config.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/config.h	(revision 4700)
+++ pjproject/trunk/pjmedia/include/pjmedia/config.h	(revision 4701)
@@ -915,4 +915,17 @@
 
 /**
+ * Let the library handle libsrtp initialization and deinitialization.
+ * Application may want to disable this and manually perform libsrtp
+ * initialization and deinitialization when it needs to use libsrtp
+ * before the library is initialized or after the library is shutdown.
+ *
+ * By default it is enabled.
+ */
+#ifndef PJMEDIA_LIBSRTP_AUTO_INIT_DEINIT
+#   define PJMEDIA_LIBSRTP_AUTO_INIT_DEINIT	    1
+#endif
+
+
+/**
  * Enable support to handle codecs with inconsistent clock rate
  * between clock rate in SDP/RTP & the clock rate that is actually used.
Index: pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c	(revision 4700)
+++ pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c	(revision 4701)
@@ -31,5 +31,9 @@
 #if defined(PJMEDIA_HAS_SRTP) && (PJMEDIA_HAS_SRTP != 0)
 
-#include <srtp.h>
+#if defined(PJMEDIA_EXTERNAL_SRTP) && (PJMEDIA_EXTERNAL_SRTP != 0)
+#  include <srtp/srtp.h>
+#else
+#  include <srtp.h>
+#endif
 
 #define THIS_FILE   "transport_srtp.c"
@@ -277,4 +281,5 @@
 PJ_DEF(pj_status_t) pjmedia_srtp_init_lib(pjmedia_endpt *endpt)
 {
+#if PJMEDIA_LIBSRTP_AUTO_INIT_DEINIT
     if (libsrtp_initialized == PJ_FALSE) {
 	err_status_t err;
@@ -299,4 +304,7 @@
 	libsrtp_initialized = PJ_TRUE;
     }
+#else
+    PJ_UNUSED_ARG(endpt);
+#endif
     
     return PJ_SUCCESS;
Index: pjproject/trunk/third_party/build/Makefile
===================================================================
--- pjproject/trunk/third_party/build/Makefile	(revision 4700)
+++ pjproject/trunk/third_party/build/Makefile	(revision 4701)
@@ -1,3 +1,3 @@
-DIRS = resample milenage srtp
+DIRS = milenage
 
 include ../../build.mak
Index: pjproject/trunk/third_party/build/os-auto.mak.in
===================================================================
--- pjproject/trunk/third_party/build/os-auto.mak.in	(revision 4700)
+++ pjproject/trunk/third_party/build/os-auto.mak.in	(revision 4701)
@@ -32,2 +32,11 @@
 endif
 
+ifeq (@ac_external_srtp@,1)
+# External SRTP
+else
+DIRS += srtp
+endif
+
+ifeq (@ac_pjmedia_resample@,libresample)
+DIRS += resample
+endif
Index: pjproject/trunk/third_party/build/os-darwinos.mak
===================================================================
--- pjproject/trunk/third_party/build/os-darwinos.mak	(revision 4700)
+++ pjproject/trunk/third_party/build/os-darwinos.mak	(revision 4701)
@@ -4,4 +4,6 @@
 DIRS += portaudio
 DIRS += g7221
+DIRS += srtp
+DIRS += resample
 
 
Index: pjproject/trunk/third_party/build/os-linux.mak
===================================================================
--- pjproject/trunk/third_party/build/os-linux.mak	(revision 4700)
+++ pjproject/trunk/third_party/build/os-linux.mak	(revision 4701)
@@ -4,4 +4,6 @@
 DIRS += portaudio
 DIRS += g7221
+DIRS += srtp
+DIRS += resample
 
 
Index: pjproject/trunk/third_party/build/os-win32.mak
===================================================================
--- pjproject/trunk/third_party/build/os-win32.mak	(revision 4700)
+++ pjproject/trunk/third_party/build/os-win32.mak	(revision 4701)
@@ -4,4 +4,6 @@
 DIRS += portaudio
 DIRS += g7221
+DIRS += srtp
+DIRS += resample
 
 