Index: /pjproject/trunk/pjlib-util/src/pjlib-util/dns.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/dns.c	(revision 4711)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/dns.c	(revision 4712)
@@ -60,5 +60,5 @@
 				       const pj_str_t *name)
 {
-    pj_uint8_t *query, *p = (pj_uint8_t*)packet;
+    pj_uint8_t *p = (pj_uint8_t*)packet;
     const char *startlabel, *endlabel, *endname;
     pj_size_t d;
@@ -81,5 +81,5 @@
 
     /* Initialize query */
-    query = p = ((pj_uint8_t*)packet)+sizeof(pj_dns_hdr);
+    p = ((pj_uint8_t*)packet)+sizeof(pj_dns_hdr);
 
     /* Tokenize name */
Index: /pjproject/trunk/pjlib/src/pjlib-test/test.c
===================================================================
--- /pjproject/trunk/pjlib/src/pjlib-test/test.c	(revision 4711)
+++ /pjproject/trunk/pjlib/src/pjlib-test/test.c	(revision 4712)
@@ -216,8 +216,7 @@
 int test_main(void)
 {
-    int i;
     PJ_USE_EXCEPTION;
 
-    i = pj_AF_INET();
+    pj_AF_INET();
 
     PJ_TRY {
Index: /pjproject/trunk/pjmedia/src/pjmedia/rtcp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 4711)
+++ /pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 4712)
@@ -288,5 +288,4 @@
     pj_int32_t transit;
     pjmedia_rtp_status seq_st;
-    unsigned last_seq;
 
 #if !defined(PJMEDIA_HAS_RTCP_XR) || (PJMEDIA_HAS_RTCP_XR == 0)
@@ -303,5 +302,4 @@
 
     /* Process the RTP packet. */
-    last_seq = sess->seq_ctrl.max_seq;
     pjmedia_rtp_seq_update(&sess->seq_ctrl, (pj_uint16_t)seq, &seq_st);
 
@@ -808,5 +806,4 @@
 {
     pj_uint32_t expected, expected_interval, received_interval, lost_interval;
-    pjmedia_rtcp_common *common;
     pjmedia_rtcp_sr *sr;
     pjmedia_rtcp_rr *rr;
@@ -829,5 +826,4 @@
 	*ret_p_pkt = (void*) &sess->rtcp_sr_pkt;
 	*len = sizeof(pjmedia_rtcp_sr_pkt);
-	common = &sess->rtcp_sr_pkt.common;
 	rr = &sess->rtcp_sr_pkt.rr;
 	sr = &sess->rtcp_sr_pkt.sr;
@@ -860,5 +856,4 @@
 	*ret_p_pkt = (void*) &sess->rtcp_rr_pkt;
 	*len = sizeof(pjmedia_rtcp_rr_pkt);
-	common = &sess->rtcp_rr_pkt.common;
 	rr = &sess->rtcp_rr_pkt.rr;
 	sr = NULL;
Index: /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 4711)
+++ /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 4712)
@@ -1034,5 +1034,4 @@
     unsigned i;
     pj_bool_t master_has_codec = 0,
-	      master_has_telephone_event = 0,
 	      master_has_other = 0,
 	      found_matching_codec = 0,
@@ -1130,5 +1129,4 @@
 
 		if (!pj_stricmp2(&or_.enc_name, "telephone-event")) {
-		    master_has_telephone_event = 1;
 		    if (found_matching_telephone_event)
 			continue;
Index: /pjproject/trunk/pjmedia/src/test/codec_vectors.c
===================================================================
--- /pjproject/trunk/pjmedia/src/test/codec_vectors.c	(revision 4711)
+++ /pjproject/trunk/pjmedia/src/test/codec_vectors.c	(revision 4712)
@@ -127,7 +127,5 @@
 
 	if (out_frame.size) {
-	    pj_size_t cnt;
-
-	    cnt = fwrite(out_frame.buf, out_frame.size, 1, output);
+	    fwrite(out_frame.buf, out_frame.size, 1, output);
 
 	    if (encoded_frame_len == 0)
Index: /pjproject/trunk/pjnath/src/pjnath/stun_msg.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 4711)
+++ /pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 4712)
@@ -2301,5 +2301,4 @@
     
     pj_stun_msg *msg;
-    unsigned uattr_cnt;
     const pj_uint8_t *start_pdu = pdu;
     pj_bool_t has_msg_int = PJ_FALSE;
@@ -2340,5 +2339,4 @@
 
     /* Parse attributes */
-    uattr_cnt = 0;
     while (pdu_len >= 4) {
 	unsigned attr_type, attr_val_len;
Index: /pjproject/trunk/pjnath/src/pjnath/stun_sock.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/stun_sock.c	(revision 4711)
+++ /pjproject/trunk/pjnath/src/pjnath/stun_sock.c	(revision 4712)
@@ -955,8 +955,6 @@
 process_app_data:
     if (stun_sock->cb.on_rx_data) {
-	pj_bool_t ret;
-
-	ret = (*stun_sock->cb.on_rx_data)(stun_sock, data, (unsigned)size,
-					  src_addr, addr_len);
+	(*stun_sock->cb.on_rx_data)(stun_sock, data, (unsigned)size,
+				    src_addr, addr_len);
 	status = pj_grp_lock_release(stun_sock->grp_lock);
 	return status!=PJ_EGONE ? PJ_TRUE : PJ_FALSE;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 4711)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 4712)
@@ -621,9 +621,6 @@
 static pj_status_t start_async_read(struct udp_transport *tp)
 {
-    pj_ioqueue_t *ioqueue;
     int i;
     pj_status_t status;
-
-    ioqueue = pjsip_endpt_get_ioqueue(tp->base.endpt);
 
     /* Start reading the ioqueue. */
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 4711)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 4712)
@@ -4498,10 +4498,7 @@
 	 */
 	pjsip_rx_data *rdata;
-	pjsip_msg *msg;
 	pjsip_accept_hdr *accept_hdr;
-	pj_status_t status;
 
 	rdata = e->body.tsx_state.src.rdata;
-	msg = rdata->msg_info.msg;
 
 	/* Request MUST have message body, with Content-Type equal to
@@ -4523,5 +4520,5 @@
 	 * the UI takes too long to process the message. 
 	 */
-	status = pjsip_dlg_respond( inv->dlg, rdata, 200, NULL, NULL, NULL);
+	pjsip_dlg_respond( inv->dlg, rdata, 200, NULL, NULL, NULL);
 
 	/* Process MESSAGE request */
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 4711)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 4712)
@@ -275,5 +275,4 @@
     pjsip_accept_hdr *accept_hdr;
     pjsip_msg *msg;
-    pj_status_t status;
 
     msg = rdata->msg_info.msg;
@@ -307,6 +306,6 @@
      * the UI takes too long to process the message. 
      */
-    status = pjsip_endpt_respond( pjsua_var.endpt, NULL, rdata, 200, NULL,
-				  NULL, NULL, NULL);
+    pjsip_endpt_respond( pjsua_var.endpt, NULL, rdata, 200, NULL,
+			 NULL, NULL, NULL);
 
     /* For the source URI, we use Contact header if present, since
Index: /pjproject/trunk/pjsip/src/test/msg_err_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/msg_err_test.c	(revision 4711)
+++ /pjproject/trunk/pjsip/src/test/msg_err_test.c	(revision 4712)
@@ -82,10 +82,9 @@
     for (i=0; i<PJ_ARRAY_SIZE(test_entries); ++i) {
 	pjsip_parser_err_report err_list, *e;
-	pjsip_msg *msg;
 
 	PJ_LOG(3,(THIS_FILE, "  Parsing msg %d", i));
 	pj_list_init(&err_list);
-	msg = pjsip_parse_msg(pool, test_entries[i].msg,
-			      strlen(test_entries[i].msg), &err_list);
+	pjsip_parse_msg(pool, test_entries[i].msg,
+			strlen(test_entries[i].msg), &err_list);
 
 	e = err_list.next;
Index: /pjproject/trunk/pjsip/src/test/regc_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/regc_test.c	(revision 4711)
+++ /pjproject/trunk/pjsip/src/test/regc_test.c	(revision 4712)
@@ -546,5 +546,5 @@
     pjsip_regc *regc;
     pjsip_contact_hdr *h1, *h2;
-    pjsip_sip_uri *u1, *u2;
+    pjsip_sip_uri *u1;
     unsigned i;
     pj_status_t status;
@@ -603,5 +603,4 @@
 
     u1 = (pjsip_sip_uri*) pjsip_uri_get_uri(h1->uri);
-    u2 = (pjsip_sip_uri*) pjsip_uri_get_uri(h2->uri);
 
     if (*u1->host.ptr == 'a') {