Index: /pjproject/trunk/pjlib-util/src/pjlib-util/base64.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/base64.c	(revision 4712)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/base64.c	(revision 4713)
@@ -25,5 +25,5 @@
 #define PADDING	    '='
 
-const char base64_char[] = {
+static const char base64_char[] = {
     'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
     'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/getopt.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/getopt.c	(revision 4712)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/getopt.c	(revision 4713)
@@ -112,5 +112,5 @@
    know that. */
 
-int __getopt_initialized = 0;
+static int __getopt_initialized = 0;
 
 /* The next char to be scanned in the option-element
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c	(revision 4712)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c	(revision 4713)
@@ -1497,6 +1497,6 @@
  * result at the back of the string.
  */
-void str_snprintf(pj_str_t *s, size_t size, 
-                  pj_bool_t append, const char *format, ...)
+static void str_snprintf(pj_str_t *s, size_t size, 
+			 pj_bool_t append, const char *format, ...)
 {
     va_list arg;
Index: /pjproject/trunk/pjlib/src/pj/pool_buf.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/pool_buf.c	(revision 4712)
+++ /pjproject/trunk/pjlib/src/pj/pool_buf.c	(revision 4713)
@@ -22,5 +22,5 @@
 #include <pj/os.h>
 
-struct pj_pool_factory stack_based_factory;
+static struct pj_pool_factory stack_based_factory;
 
 struct creation_param
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/g722/g722_dec.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/g722/g722_dec.c	(revision 4712)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/g722/g722_dec.c	(revision 4713)
@@ -451,5 +451,5 @@
 }
 
-void rx_qmf(g722_dec_t *dec, int rl, int rh, int *xout1, int *xout2)
+static void rx_qmf(g722_dec_t *dec, int rl, int rh, int *xout1, int *xout2)
 {
     int i;
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c	(revision 4712)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c	(revision 4713)
@@ -726,5 +726,5 @@
  * Returns 0 if a frame found, otherwise returns -1.
  */
-int speex_get_next_frame(SpeexBits *bits)
+static int speex_get_next_frame(SpeexBits *bits)
 {
     static const int inband_skip_table[NB_SUBMODES] =
Index: /pjproject/trunk/pjmedia/src/pjmedia/echo_suppress.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/echo_suppress.c	(revision 4712)
+++ /pjproject/trunk/pjmedia/src/pjmedia/echo_suppress.c	(revision 4713)
@@ -126,5 +126,5 @@
 } talk_state_t;
 
-const char *state_names[] = 
+static const char *state_names[] = 
 {
     "Null",
Index: /pjproject/trunk/pjnath/src/pjnath/ice_session.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 4712)
+++ /pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 4713)
@@ -1987,6 +1987,6 @@
 
 /* Utility: find string in string array */
-const pj_str_t *find_str(const pj_str_t *strlist[], unsigned count,
-			 const pj_str_t *str)
+static const pj_str_t *find_str(const pj_str_t *strlist[], unsigned count,
+				const pj_str_t *str)
 {
     unsigned i;
Index: /pjproject/trunk/pjsip/src/pjsip-simple/presence.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-simple/presence.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsip-simple/presence.c	(revision 4713)
@@ -131,11 +131,11 @@
  * Some static constants.
  */
-const pj_str_t STR_EVENT	    = { "Event", 5 };
-const pj_str_t STR_PRESENCE	    = { "presence", 8 };
-const pj_str_t STR_APPLICATION	    = { "application", 11 };
-const pj_str_t STR_PIDF_XML	    = { "pidf+xml", 8};
-const pj_str_t STR_XPIDF_XML	    = { "xpidf+xml", 9};
-const pj_str_t STR_APP_PIDF_XML	    = { "application/pidf+xml", 20 };
-const pj_str_t STR_APP_XPIDF_XML    = { "application/xpidf+xml", 21 };
+static const pj_str_t STR_EVENT	    = { "Event", 5 };
+static const pj_str_t STR_PRESENCE	    = { "presence", 8 };
+static const pj_str_t STR_APPLICATION	    = { "application", 11 };
+static const pj_str_t STR_PIDF_XML	    = { "pidf+xml", 8};
+static const pj_str_t STR_XPIDF_XML	    = { "xpidf+xml", 9};
+static const pj_str_t STR_APP_PIDF_XML	    = { "application/pidf+xml", 20 };
+static const pj_str_t STR_APP_XPIDF_XML    = { "application/xpidf+xml", 21 };
 
 
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_100rel.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_100rel.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_100rel.c	(revision 4713)
@@ -51,7 +51,7 @@
 
 
-const pj_str_t tag_100rel = { "100rel", 6 };
-const pj_str_t RSEQ = { "RSeq", 4 };
-const pj_str_t RACK = { "RAck", 4 };
+static const pj_str_t tag_100rel = { "100rel", 6 };
+static const pj_str_t RSEQ = { "RSeq", 4 };
+static const pj_str_t RACK = { "RAck", 4 };
 
 
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 4713)
@@ -193,6 +193,6 @@
  * Set session state.
  */
-void inv_set_state(pjsip_inv_session *inv, pjsip_inv_state state,
-		   pjsip_event *e)
+static void inv_set_state(pjsip_inv_session *inv, pjsip_inv_state state,
+			  pjsip_event *e)
 {
     pjsip_inv_state prev_state = inv->state;
@@ -284,6 +284,6 @@
  * Set cause code.
  */
-void inv_set_cause(pjsip_inv_session *inv, int cause_code,
-		   const pj_str_t *cause_text)
+static void inv_set_cause(pjsip_inv_session *inv, int cause_code,
+			  const pj_str_t *cause_text)
 {
     if (cause_code > inv->cause) {
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 4713)
@@ -77,8 +77,8 @@
  * String constants
  */
-const pj_str_t STR_REFER = { "refer", 5 };
-const pj_str_t STR_MESSAGE = { "message", 7 };
-const pj_str_t STR_SIPFRAG = { "sipfrag", 7 };
-const pj_str_t STR_SIPFRAG_VERSION = {";version=2.0", 12 };
+static const pj_str_t STR_REFER = { "refer", 5 };
+static const pj_str_t STR_MESSAGE = { "message", 7 };
+static const pj_str_t STR_SIPFRAG = { "sipfrag", 7 };
+static const pj_str_t STR_SIPFRAG_VERSION = {";version=2.0", 12 };
 
 
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 4713)
@@ -131,5 +131,5 @@
  * Transport names.
  */
-struct transport_names_t
+static struct transport_names_t
 {
     pjsip_transport_type_e type;	    /* Transport type	    */
@@ -218,5 +218,5 @@
 
 
-struct transport_names_t *get_tpname(pjsip_transport_type_e type)
+static struct transport_names_t *get_tpname(pjsip_transport_type_e type)
 {
     unsigned i;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 4713)
@@ -68,6 +68,6 @@
 
 /* Helper function to create "incoming" packet */
-struct recv_list *create_incoming_packet( struct loop_transport *loop,
-					  pjsip_tx_data *tdata )
+static struct recv_list *create_incoming_packet( struct loop_transport *loop,
+						 pjsip_tx_data *tdata )
 {
     pj_pool_t *pool;
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c	(revision 4713)
@@ -1788,5 +1788,5 @@
 
 /* Check and update Service-Route header */
-void update_service_route(pjsua_acc *acc, pjsip_rx_data *rdata)
+static void update_service_route(pjsua_acc *acc, pjsip_rx_data *rdata)
 {
     pjsip_generic_string_hdr *hsr = NULL;
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 4712)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 4713)
@@ -75,8 +75,8 @@
 
 /* Acquire lock to the specified buddy_id */
-pj_status_t lock_buddy(const char *title,
-		       pjsua_buddy_id buddy_id,
-		       struct buddy_lock *lck,
-		       unsigned _unused_)
+static pj_status_t lock_buddy(const char *title,
+			      pjsua_buddy_id buddy_id,
+			      struct buddy_lock *lck,
+			      unsigned _unused_)
 {
     enum { MAX_RETRY=50 };